<?php

class PlaceCategory extends DataObject
{

    private static $db = [
        'Name' => 'Varchar(255)',
	    'Key' => 'Varchar(255)'
    ];

    private static $belongs_many_many = [
        'Places' => 'Place',
	    'ThingsToDoMaps' => 'ThingsToDoMapBlock'
    ];

    private static $has_one = [
    	'Icon' => 'CloudImage',
	    'MapPin' => 'CloudImage'
    ];

	public function getCMSFields()
	{
		$fields = parent::getCMSFields();
		$fields->removeByName('IconID');

		if ($this->ID) {
			if (!FieldGenerator::isFieldHidden('PlaceCategory', 'Icon')) {
				$icon = FieldGenerator::getImageField($fields, [
					'model' => PlaceCategory::class,
					'modelId' => $this->ID,
					'fieldName' => 'Icon'
				]);
				$fields->addFieldsToTab('Root.Main', $icon);
			}

			if (!FieldGenerator::isFieldHidden('PlaceCategory', 'MapPin')) {
				$mapPin = FieldGenerator::getImageField($fields, [
					'model' => PlaceCategory::class,
					'modelId' => $this->ID,
					'fieldName' => 'MapPin'
				]);
				$fields->addFieldsToTab('Root.Main', $mapPin);
			}



			$fields->removeByName('ThingsToDoMaps');
			$fields->removeByName('Places');
		}
		return $fields;
    }

    protected function onBeforeWrite()
    {
	    if (isset($_REQUEST['removeIcon']) && $_REQUEST['removeIcon']) {
		    $this->IconID = 0;
	    }
	    parent::onBeforeWrite();
    }

}